std::tuple< _T1, _T2 > Class Template Reference
Utilities

`#include <tuple>`

Inheritance diagram for std::tuple< _T1, _T2 >:
[legend]

## Public Member Functions

template<typename _U1 , typename _U2 , _ImplicitCtor<!__is_alloc_arg< _U1 >(), _U1, _U2 > = true>
constexpr | tuple (_U1 &&__a1, _U2 &&__a2) noexcept(__nothrow_constructible< _U1, _U2 >())
template<typename _U1 , typename _U2 , _ExplicitCtor<!__is_alloc_arg< _U1 >(), _U1, _U2 > = false>
constexpr | tuple (_U1 &&__a1, _U2 &&__a2) noexcept(__nothrow_constructible< _U1, _U2 >())
template<typename _Alloc , _ImplicitDefaultCtor< is_object< _Alloc >::value, _T1, _T2 > = true>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a)
template<typename _Alloc , _ExplicitDefaultCtor< is_object< _Alloc >::value, _T1, _T2 > = false>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a)
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, _U1 &&__a1, _U2 &&__a2)
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, _U1 &&__a1, _U2 &&__a2)
template<typename _Alloc , bool _Dummy = true, _ImplicitCtor< _Dummy, const _T1 &, const _T2 & > = true>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, const _T1 &__a1, const _T2 &__a2)
template<typename _Alloc , bool _Dummy = true, _ExplicitCtor< _Dummy, const _T1 &, const _T2 & > = false>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, const _T1 &__a1, const _T2 &__a2)
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, const pair< _U1, _U2 > &__in)
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, const pair< _U1, _U2 > &__in)
template<typename _Alloc >
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, const tuple &__in)
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, const tuple< _U1, _U2 > &__in)
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, const tuple< _U1, _U2 > &__in)
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, pair< _U1, _U2 > &&__in)
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, pair< _U1, _U2 > &&__in)
template<typename _Alloc >
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, tuple &&__in)
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, tuple< _U1, _U2 > &&__in)
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>
constexpr | tuple (allocator_arg_t __tag, const _Alloc &__a, tuple< _U1, _U2 > &&__in)
template<bool _Dummy = true, _ImplicitCtor< _Dummy, const _T1 &, const _T2 & > = true>
constexpr | tuple (const _T1 &__a1, const _T2 &__a2) noexcept(__nothrow_constructible< const _T1 &, const _T2 & >())
template<bool _Dummy = true, _ExplicitCtor< _Dummy, const _T1 &, const _T2 & > = false>
constexpr | tuple (const _T1 &__a1, const _T2 &__a2) noexcept(__nothrow_constructible< const _T1 &, const _T2 & >())
template<typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>
constexpr | tuple (const pair< _U1, _U2 > &__in) noexcept(__nothrow_constructible< const _U1 &, const _U2 & >())
template<typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>
constexpr | tuple (const pair< _U1, _U2 > &__in) noexcept(__nothrow_constructible< const _U1 &, const _U2 & >())
constexpr | tuple (const tuple &)=default
template<typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>
constexpr | tuple (const tuple< _U1, _U2 > &__in) noexcept(__nothrow_constructible< const _U1 &, const _U2 & >())
template<typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>
constexpr | tuple (const tuple< _U1, _U2 > &__in) noexcept(__nothrow_constructible< const _U1 &, const _U2 & >())
template<typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>
constexpr | tuple (pair< _U1, _U2 > &&__in) noexcept(__nothrow_constructible< _U1, _U2 >())
template<typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>
constexpr | tuple (pair< _U1, _U2 > &&__in) noexcept(__nothrow_constructible< _U1, _U2 >())
constexpr | tuple (tuple &&)=default
template<typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>
constexpr | tuple (tuple< _U1, _U2 > &&__in) noexcept(__nothrow_constructible< _U1, _U2 >())
template<typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>
constexpr | tuple (tuple< _U1, _U2 > &&__in) noexcept(__nothrow_constructible< _U1, _U2 >())
template<typename _U1 , typename _U2 >
constexpr __enable_if_t< __assignable< const _U1 &, const _U2 & >(), tuple & > | operator= (const pair< _U1, _U2 > &__in) noexcept(__nothrow_assignable< const _U1 &, const _U2 & >())
template<typename _U1 , typename _U2 >
constexpr __enable_if_t< __assignable< const _U1 &, const _U2 & >(), tuple & > | operator= (const tuple< _U1, _U2 > &__in) noexcept(__nothrow_assignable< const _U1 &, const _U2 & >())
template<typename _U1 , typename _U2 >
constexpr __enable_if_t< __assignable< _U1, _U2 >(), tuple & > | operator= (pair< _U1, _U2 > &&__in) noexcept(__nothrow_assignable< _U1, _U2 >())
template<typename _U1 , typename _U2 >
constexpr __enable_if_t< __assignable< _U1, _U2 >(), tuple & > | operator= (tuple< _U1, _U2 > &&__in) noexcept(__nothrow_assignable< _U1, _U2 >())
constexpr tuple & | operator= (typename conditional< __assignable< _T1, _T2 >(), tuple &&, __nonesuch && >::type __in) noexcept(__nothrow_assignable< _T1, _T2 >())
constexpr tuple & | operator= (typename conditional< __assignable< const _T1 &, const _T2 & >(), const tuple &, const __nonesuch & >::type __in) noexcept(__nothrow_assignable< const _T1 &, const _T2 & >())
constexpr void | swap (tuple &__in) noexcept(__and_< __is_nothrow_swappable< _T1 >, __is_nothrow_swappable< _T2 > >::value)

## Detailed Description

template<typename _T1, typename _T2>
class std::tuple< _T1, _T2 >

Partial specialization, 2-element tuple. Includes construction and assignment from a pair.

Definition at line 988 of file tuple.

## Constructor & Destructor Documentation

## tuple() [1/30]

template<typename _T1 , typename _T2 >
template<bool _Dummy = true, _ImplicitDefaultCtor< _Dummy, _T1, _T2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( |  | ) |

inline constexpr noexcept

Definition at line 1056 of file tuple.

## tuple() [2/30]

template<typename _T1 , typename _T2 >
template<bool _Dummy = true, _ExplicitDefaultCtor< _Dummy, _T1, _T2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( |  | ) |

inline explicit constexpr noexcept

Definition at line 1063 of file tuple.

## tuple() [3/30]

template<typename _T1 , typename _T2 >
template<bool _Dummy = true, _ImplicitCtor< _Dummy, const _T1 &, const _T2 & > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | const _T1 & | __a1,
|  | const _T2 & | __a2
| ) |  |

inline constexpr noexcept

Definition at line 1070 of file tuple.

## tuple() [4/30]

template<typename _T1 , typename _T2 >
template<bool _Dummy = true, _ExplicitCtor< _Dummy, const _T1 &, const _T2 & > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | const _T1 & | __a1,
|  | const _T2 & | __a2
| ) |  |

inline explicit constexpr noexcept

Definition at line 1077 of file tuple.

## tuple() [5/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ImplicitCtor<!__is_alloc_arg< _U1 >(), _U1, _U2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | _U1 && | __a1,
|  | _U2 && | __a2
| ) |  |

inline constexpr noexcept

Definition at line 1084 of file tuple.

## tuple() [6/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ExplicitCtor<!__is_alloc_arg< _U1 >(), _U1, _U2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | _U1 && | __a1,
|  | _U2 && | __a2
| ) |  |

inline explicit constexpr noexcept

Definition at line 1091 of file tuple.

## tuple() [7/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | const tuple< _U1, _U2 > & | __in | ) |

inline constexpr noexcept

Definition at line 1102 of file tuple.

## tuple() [8/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | const tuple< _U1, _U2 > & | __in | ) |

inline explicit constexpr noexcept

Definition at line 1109 of file tuple.

## tuple() [9/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | tuple< _U1, _U2 > && | __in | ) |

inline constexpr noexcept

Definition at line 1116 of file tuple.

## tuple() [10/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | tuple< _U1, _U2 > && | __in | ) |

inline explicit constexpr noexcept

Definition at line 1123 of file tuple.

## tuple() [11/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | const pair< _U1, _U2 > & | __in | ) |

inline constexpr noexcept

Definition at line 1130 of file tuple.

## tuple() [12/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | const pair< _U1, _U2 > & | __in | ) |

inline explicit constexpr noexcept

Definition at line 1137 of file tuple.

## tuple() [13/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | pair< _U1, _U2 > && | __in | ) |

inline constexpr noexcept

Definition at line 1144 of file tuple.

## tuple() [14/30]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | pair< _U1, _U2 > && | __in | ) |

inline explicit constexpr noexcept

Definition at line 1152 of file tuple.

## tuple() [15/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , _ImplicitDefaultCtor< is_object< _Alloc >::value, _T1, _T2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a
| ) |  |

inline constexpr

Definition at line 1162 of file tuple.

## tuple() [16/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , _ExplicitDefaultCtor< is_object< _Alloc >::value, _T1, _T2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a
| ) |  |

inline explicit constexpr

Definition at line 1169 of file tuple.

## tuple() [17/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , bool _Dummy = true, _ImplicitCtor< _Dummy, const _T1 &, const _T2 & > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | const _T1 & | __a1,
|  | const _T2 & | __a2
| ) |  |

inline constexpr

Definition at line 1175 of file tuple.

## tuple() [18/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , bool _Dummy = true, _ExplicitCtor< _Dummy, const _T1 &, const _T2 & > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | const _T1 & | __a1,
|  | const _T2 & | __a2
| ) |  |

inline explicit constexpr

Definition at line 1183 of file tuple.

## tuple() [19/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | _U1 && | __a1,
|  | _U2 && | __a2
| ) |  |

inline constexpr

Definition at line 1190 of file tuple.

## tuple() [20/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | _U1 && | __a1,
|  | _U2 && | __a2
| ) |  |

inline explicit constexpr

Definition at line 1198 of file tuple.

## tuple() [21/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc >

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | const tuple< _T1, _T2 > & | __in
| ) |  |

inline constexpr

Definition at line 1205 of file tuple.

## tuple() [22/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc >

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | tuple< _T1, _T2 > && | __in
| ) |  |

inline constexpr

Definition at line 1210 of file tuple.

## tuple() [23/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | const tuple< _U1, _U2 > & | __in
| ) |  |

inline constexpr

Definition at line 1216 of file tuple.

## tuple() [24/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | const tuple< _U1, _U2 > & | __in
| ) |  |

inline explicit constexpr

Definition at line 1226 of file tuple.

## tuple() [25/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | tuple< _U1, _U2 > && | __in
| ) |  |

inline constexpr

Definition at line 1235 of file tuple.

## tuple() [26/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | tuple< _U1, _U2 > && | __in
| ) |  |

inline explicit constexpr

Definition at line 1243 of file tuple.

## tuple() [27/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, const _U1 &, const _U2 & > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | const pair< _U1, _U2 > & | __in
| ) |  |

inline constexpr

Definition at line 1250 of file tuple.

## tuple() [28/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, const _U1 &, const _U2 & > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | const pair< _U1, _U2 > & | __in
| ) |  |

inline explicit constexpr

Definition at line 1258 of file tuple.

## tuple() [29/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ImplicitCtor< true, _U1, _U2 > = true>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | pair< _U1, _U2 > && | __in
| ) |  |

inline constexpr

Definition at line 1265 of file tuple.

## tuple() [30/30]

template<typename _T1 , typename _T2 >
template<typename _Alloc , typename _U1 , typename _U2 , _ExplicitCtor< true, _U1, _U2 > = false>

constexpr std::tuple< _T1, _T2 >::tuple | ( | allocator_arg_t | __tag,
|  | const _Alloc & | __a,
|  | pair< _U1, _U2 > && | __in
| ) |  |

inline explicit constexpr

Definition at line 1273 of file tuple.

## Member Function Documentation

## operator=() [1/6]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 >

constexpr __enable_if_t< __assignable< const _U1 &, const _U2 & >(), tuple & > std::tuple< _T1, _T2 >::operator= | ( | const pair< _U1, _U2 > & | __in | ) |

inline constexpr noexcept

Definition at line 1324 of file tuple.

## operator=() [2/6]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 >

constexpr __enable_if_t< __assignable< const _U1 &, const _U2 & >(), tuple & > std::tuple< _T1, _T2 >::operator= | ( | const tuple< _U1, _U2 > & | __in | ) |

inline constexpr noexcept

Definition at line 1304 of file tuple.

## operator=() [3/6]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 >

constexpr __enable_if_t< __assignable< _U1, _U2 >(), tuple & > std::tuple< _T1, _T2 >::operator= | ( | pair< _U1, _U2 > && | __in | ) |

inline constexpr noexcept

Definition at line 1335 of file tuple.

## operator=() [4/6]

template<typename _T1 , typename _T2 >
template<typename _U1 , typename _U2 >

constexpr __enable_if_t< __assignable< _U1, _U2 >(), tuple & > std::tuple< _T1, _T2 >::operator= | ( | tuple< _U1, _U2 > && | __in | ) |

inline constexpr noexcept

Definition at line 1314 of file tuple.

## operator=() [5/6]

template<typename _T1 , typename _T2 >

constexpr tuple & std::tuple< _T1, _T2 >::operator= | ( | typename conditional< __assignable< _T1, _T2 >(), tuple< _T1, _T2 > &&, __nonesuch && >::type | __in | ) |

inline constexpr noexcept

Definition at line 1292 of file tuple.

## operator=() [6/6]

template<typename _T1 , typename _T2 >

constexpr tuple & std::tuple< _T1, _T2 >::operator= | ( | typename conditional< __assignable< const _T1 &, const _T2 & >(), const tuple< _T1, _T2 > &, const __nonesuch & >::type | __in | ) |

inline constexpr noexcept

Definition at line 1281 of file tuple.

## swap()

template<typename _T1 , typename _T2 >

constexpr void std::tuple< _T1, _T2 >::swap | ( | tuple< _T1, _T2 > & | __in | ) |

inline constexpr noexcept

Definition at line 1345 of file tuple.

The documentation for this class was generated from the following file:

- tuple